<script setup lang="ts">
// Update to state when portal resize=

import { storeToRefs } from 'pinia'
import { audioComfirm } from '~/composables/zoomUI'
import { useZoomClientStore } from '~/store/zoomClient'
import { useUIStore } from '~~/store/UI'

// Toggle full view

const zoomClient = useZoomClientStore()
const { loading } = storeToRefs(zoomClient)
const ui = useUIStore()
const portal = ref<HTMLImageElement | null>(null)
const { height, width, x, y } = useElementBounding(portal)

const cssStyleSheet = computed(() => {
  return `#zmmtg-root {
    transform-origin: 0 0;
    top: ${y.value}px;
    left: ${x.value}px;
    height: ${height.value}px;
    width: ${width.value}px;
    transform: translate(0,0);
    }
    #zmmtg-root *{
      max-height: ${height.value}px;
    }
  `
})

watchEffect(() => zoomClient.position = {
  x: x.value,
  y: y.value,
  w: width.value,
  h: height.value,
  scale: 1,
})
watchEffect(() => {
  window.innerWidth = width.value
  window.innerHeight = height.value
  window.dispatchEvent(new Event('resize'))
})

useStyleTag(cssStyleSheet)

// share
const host = ref(false)
useIntervalFn(() => {
  const button = document.querySelector('.SplitPane.vertical')
  if (button)
    host.value = true
  else
    host.value = false
}, 500)

watch(() => host.value,
  (value, oldValue) => {
    if (!oldValue && value)
      zoomUiModify()
  },
)

// audio observer

const callback = (mutationList: MutationRecord[], observer: MutationObserver) => {
  const mutation = mutationList.find(m => m.type === 'childList')
  if (mutation && mutation.addedNodes[0]?.className === 'join-dialog')
    audioComfirm()
}
const observer = new MutationObserver(callback)

watch(() => loading.value,
  (newValue, oldValue) => {
    if (!newValue && oldValue) {
      const targetNode = document.querySelector('.meeting-client-inner')
      if (targetNode)
        observer.observe(targetNode, { childList: true })
    }
  })
onUnmounted(() => {
  observer.disconnect()
})

// waiting
const { waitingRoom, fullView, designNumber } = storeToRefs(ui)
</script>

<template>
  <div ref="portal" class="flex-1 relative pointer-events-none z-40 slot2">
    <div
      v-if="loading"
      class="z-40 absolute inset-0 bg-neutral-900 flex justify-center items-center"
    >
      <div flex gap-4>
        <div class="i-line-md:loading-loop w-10 h-10" />
        <p class="text-4xl">
          接続中
        </p>
      </div>
    </div>
    <AWaitting v-if="waitingRoom" />
    <button
      v-if="(designNumber !== 7)"
      class="w-10 h-10 flex justify-center items-center bg-neutral-700  absolute bottom-5 right-5 z-10 pointer-events-auto"
      @click="(fullView = !fullView)"
    >
      <div class=" w-6 h-6" :class="fullView ? 'i-radix-icons:exit-full-screen' : 'i-radix-icons:enter-full-screen'" />
    </button>
  </div>
</template>

<style>

</style>
